//
//  RenameClient.m
//  VoiceToolOSX
//
//  Created by Taihei Monma on Wed Sep 03 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import "RenameClient.h"


@implementation RenameClient

- (id)initWithDir:(NSString *)dir game:(int)g method:(int)m
		from:(NSString *)from to:(NSString *)to parent:(id <ControllerProtocol>)aParent
{
	[super init];
	
	renameDir = [dir retain];
	fromExt = [from retain];
	toExt = [to retain];
	controller = aParent;
	game = g;
	method = m;
	
	return self;
}

- (void)dealloc
{
	[renameDir release];
	[fromExt release];
	[toExt release];
	
	[super dealloc];
}

- (void)doRename
{
	[NSThread detachNewThreadSelector:@selector(voiceRename)
                             toTarget:self 	withObject:nil];
}

- (void)voiceRename
{
	NSAutoreleasePool *pool;
	pool = [[NSAutoreleasePool alloc] init];
	
	int l,n,i,j;
	int num = 0;
	char *dir;
	char *fromext;
	char *toext;
	char nomixerpath[256];
	char mixerpath[256];
	char wavedir[256];
	char oldname[256];
	char newname[256];
	int Voicenum[26];
	int KanonVoicenum[12]={
		3348,2750,1877,971,1281,
		651,423,947,191,139,
		40,230,
	};

	int AirVoicenum[26]={
		666,4892,3019,213,202,19,
		0,8,42,46,27,
		1376,1253,240,109,17,
		14,1867,1484,102,10,
		788,691,80,42,425,
	};
	
	dir = [renameDir UTF8String];
	fromext = [fromExt UTF8String];
	toext = [toExt UTF8String];
	
	/* パスの最後は必ずslash */
	
	l=strlen(dir)-1;
	strcpy(wavedir,dir);
	if(dir[l]!='/'){
		wavedir[l+1]='/';
		wavedir[l+2]='\0';
	}
	/* KanonかAIRか */
	
	if(game == 0) {	//Kanon
		num = 12;
		for(n = 0; n < num; n++) {
			Voicenum[n] = KanonVoicenum[n];
		}
		[controller setProgressMaxValue: 12848];
	}
	if(game == 1) {	//AIR
		num = 26;
		for(n = 0; n < num; n++) {
			Voicenum[n] = AirVoicenum[n];
		}
		[controller setProgressMaxValue: 17632];
	}
	
	/* メイン・ルーチン */
	
	for(i = 0; i < num; i++) {	//キャラクタの数だけ
		n = 1;
		if(game == 0) {	//Kanon
			sprintf(nomixerpath, "%s%x",wavedir,i);
			sprintf(mixerpath, "%s1%02d0",wavedir,i);
			//printf(" Renaming %s(%d/12)...¥n",KanonVoice[i],i+1);
		}
		if(game == 1) {	//AIR
			sprintf(nomixerpath, "%s%02d",wavedir,i);
			sprintf(mixerpath, "%s1%02d",wavedir,i);
			//printf(" Renaming %s(%d/26)...¥n",AirVoice[i],i+1);
		}
		
		if(method == 1) {	//without Mixer -> with Mixer
			
			for(j = 0; j < Voicenum[i]; j++) {
				sprintf(oldname,"%s/%04x%s",nomixerpath,j,fromext);
				sprintf(newname,"%s/Z1%02d%05d%s",nomixerpath,i,j+1,toext);
				rename(oldname,newname);
				[controller addProgress];
			}
			
			rename(nomixerpath,mixerpath);
			
		}
		if(method == 0) {	//with Mixer -> without Mixer
			
			for(j = 0; j < Voicenum[i]; j++) {
				sprintf(oldname,"%s/Z1%02d%05d%s",mixerpath,i,j+1,fromext);
				sprintf(newname,"%s/%04x%s",mixerpath,j,toext);
				rename(oldname,newname);
				[controller addProgress];
			}
			rename(mixerpath,nomixerpath);
			
		}
		if(method == 2) {	//no modify
			
			for(j = 0; j < Voicenum[i]; j++) {
				sprintf(oldname,"%s/Z1%02d%05d%s",mixerpath,i,j+1,fromext);
				sprintf(newname,"%s/Z1%02d%05d%s",mixerpath,i,j+1,toext);
				rename(oldname,newname);
				sprintf(oldname,"%s/%04x%s",nomixerpath,j,fromext);
				sprintf(newname,"%s/%04x%s",nomixerpath,j,toext);
				rename(oldname,newname);
				[controller addProgress];
			}
			
		}
	}
	[controller renameFinished];
	[pool release];
}

@end

