/* VoiceToolController */

#import <Cocoa/Cocoa.h>
#import "PatchClient.h"
#import "VoiceClient.h"
#import "RenameClient.h"

@interface VoiceToolController : NSObject <ControllerProtocol>
{
    IBOutlet id extensionFrom;
	IBOutlet id extensionTo;
	IBOutlet id gameKind;
    IBOutlet id isMixerPatch;
    IBOutlet id isMixerVoice;
	IBOutlet id mainWindow;
    IBOutlet id patchFile;
    IBOutlet id patchGame;
    IBOutlet id progressBar1;
	IBOutlet id progressBar2;
	IBOutlet id progressBar3;
    IBOutlet id renameDir;
    IBOutlet id renameType;
    IBOutlet id saveDir;
    IBOutlet id seenDir;
    IBOutlet id selectButton1;
    IBOutlet id selectButton2;
    IBOutlet id selectButton3;
    IBOutlet id selectButton4;
    IBOutlet id selectButton5;
    IBOutlet id startButton1;
    IBOutlet id startButton2;
    IBOutlet id startButton3;
	IBOutlet id status1;
	IBOutlet id status2;
	IBOutlet id status3;
    IBOutlet id voiceDir;
    IBOutlet id voiceKind;
	id patchClient;
	id voiceClient;
	id renameClient;
	BOOL findRunning;
	NSString *favoriteDir;
}
- (IBAction)setPatchPath:(id)sender;
- (IBAction)setRenamePath:(id)sender;
- (IBAction)setSavePath:(id)sender;
- (IBAction)setSeenPath:(id)sender;
- (IBAction)setVoicePath:(id)sender;
- (IBAction)startExpand:(id)sender;
- (IBAction)startPatch:(id)sender;
- (IBAction)startRename:(id)sender;
- (void)startProcess;
- (void)stopProcess;
- (void)pathError;
@end
