#import "VoiceToolController.h"

@implementation VoiceToolController

- (IBAction)setPatchPath:(id)sender
{
	NSOpenPanel *op;
	int stat;
	NSString *fav;
	
	op = [ NSOpenPanel openPanel ];
	
	[ op setTitle : NSLocalizedString(@"patchpath",@"") ];
	[ op setPrompt : NSLocalizedString(@"choose",@"") ];
	[ op setCanChooseDirectories : NO ];
	[ op setCanChooseFiles : YES ];
	
	if(favoriteDir) fav = favoriteDir;
	else fav = NSHomeDirectory();
	
	stat = [ op runModalForDirectory : fav
								file : nil
							   types : nil ];
							   
	if(stat == NSOKButton) {
		NSString *savePath = [ op filename ];
		favoriteDir = savePath;
		[patchFile setStringValue : savePath ];
	}
}

- (IBAction)setRenamePath:(id)sender
{
	NSOpenPanel *op;
	int stat;
	NSString *fav;
	
	op = [ NSOpenPanel openPanel ];
	
	[ op setTitle : NSLocalizedString(@"voicepath",@"") ];
	[ op setPrompt : NSLocalizedString(@"choose",@"") ];
	[ op setCanChooseDirectories : YES ];
	[ op setCanChooseFiles : NO ];
	
	if(favoriteDir) fav = favoriteDir;
	else fav = NSHomeDirectory();
	
	stat = [ op runModalForDirectory : fav
								file : nil
							   types : nil ];
							   
	if(stat == NSOKButton) {
		NSString *savePath = [ op filename ];
		favoriteDir = savePath;
		[renameDir setStringValue : savePath ];
	}
}

- (IBAction)setSavePath:(id)sender
{
	NSOpenPanel *op;
	int stat;
	NSString *fav;
	
	op = [ NSOpenPanel openPanel ];
	
	[ op setTitle : NSLocalizedString(@"savepath",@"") ];
	[ op setPrompt : NSLocalizedString(@"choose",@"") ];
	[ op setCanChooseDirectories : YES ];
	[ op setCanChooseFiles : NO ];
	
	if(favoriteDir) fav = favoriteDir;
	else fav = NSHomeDirectory();
	
	stat = [ op runModalForDirectory : fav
								file : nil
							   types : nil ];
							   
	if(stat == NSOKButton) {
		NSString *savePath = [ op filename ];
		favoriteDir = savePath;
		[saveDir setStringValue : savePath ];
	}
}

- (IBAction)setSeenPath:(id)sender
{
	NSOpenPanel *op;
	int stat;
	NSString *fav;
	
	op = [ NSOpenPanel openPanel ];
	
	[ op setTitle : NSLocalizedString(@"seenpath",@"") ];
	[ op setPrompt : NSLocalizedString(@"choose",@"") ];
	[ op setCanChooseDirectories : YES ];
	[ op setCanChooseFiles : NO ];
	
	if(favoriteDir) fav = favoriteDir;
	else fav = NSHomeDirectory();
	
	stat = [ op runModalForDirectory : fav
								file : nil
							   types : nil ];
							   
	if(stat == NSOKButton) {
		NSString *savePath = [ op filename ];
		favoriteDir = savePath;
		[seenDir setStringValue : savePath ];
	}
}

- (IBAction)setVoicePath:(id)sender
{
	NSOpenPanel *op;
	int stat;
	NSString *fav;
	
	op = [ NSOpenPanel openPanel ];
	
	[ op setTitle : NSLocalizedString(@"voicepath",@"") ];
	[ op setPrompt : NSLocalizedString(@"choose",@"") ];
	[ op setCanChooseDirectories : YES ];
	[ op setCanChooseFiles : NO ];
	
	if(favoriteDir) fav = favoriteDir;
	else fav = NSHomeDirectory();
	
	stat = [ op runModalForDirectory : fav
								file : nil
							   types : nil ];
							   
	if(stat == NSOKButton) {
		NSString *savePath = [ op filename ];
		favoriteDir = savePath;
		[voiceDir setStringValue : savePath ];
	}
}

- (IBAction)startExpand:(id)sender
{
	if([[voiceDir stringValue] isEqualToString: @""]) {
		[self pathError];
		return;
	}
	if([[saveDir stringValue] isEqualToString: @""]) {
		[self pathError];
		return;
	}
	int isMixer;
	if([isMixerVoice state] == NSOffState) isMixer = 0;
	else isMixer = 1;
	voiceClient = [[VoiceClient alloc] initWithAFSPath:[voiceDir stringValue]
								savePath:[[saveDir stringValue] stringByAppendingPathComponent: @"/"]
											game:[[voiceKind selectedItem] tag]
											isMixer:isMixer parent:self];
	//NSLog([[voiceDir stringValue] stringByAppendingPathComponent: @"/"]);
	[voiceClient doExpand];
	//[progressBar2 setIndeterminate: YES];
	//[progressBar2 startAnimation: self];
	[self startProcess];
}

- (IBAction)startPatch:(id)sender
{
	if([[seenDir stringValue] isEqualToString: @""]) {
		[self pathError];
		return;
	}
	if([[patchFile stringValue] isEqualToString: @""]) {
		[self pathError];
		return;
	}
	BOOL isMixer;
	if([isMixerPatch state] == NSOffState) isMixer = NO;
	else isMixer = YES;
	patchClient = [[PatchClient alloc] initWithSeenDir:[seenDir stringValue]
											patchFile:[patchFile stringValue] 
												game:[[patchGame selectedItem] tag]
												isMixer:isMixer parent:self];
	int ret = [patchClient doPatch];
	if(ret == 1) {
		NSBeginAlertSheet(
				@"Alert", 
				@"OK", 
				nil, 
				nil, 
				mainWindow, 
				self, 
				nil, 
				nil, 
				nil, 
				NSLocalizedString(@"seentxtnotfound",@""));
		[patchClient release];
		return;
	}
	else if(ret == 2) {
		NSBeginAlertSheet(
				@"Alert", 
				@"OK", 
				nil, 
				nil, 
				mainWindow, 
				self, 
				nil, 
				nil, 
				nil, 
				NSLocalizedString(@"seenorgexist",@""));
		[patchClient release];
		return;
	}
	//[progressBar1 setIndeterminate: YES];
	//[progressBar1 startAnimation: self];
	[self startProcess];
	
}

- (IBAction)startRename:(id)sender
{
	if([[renameDir stringValue] isEqualToString: @""]) {
		[self pathError];
		return;
	}
	
	renameClient = [[RenameClient alloc] initWithDir:[renameDir stringValue] 
												game:[[gameKind selectedItem] tag]
												method:[[renameType selectedItem] tag]
												from:[extensionFrom stringValue]
												to:[extensionTo stringValue]
												parent:self];
	[renameClient doRename];
	[self startProcess];
}

- (void)pathError
{
	NSBeginAlertSheet(
				@"Alert", 
				@"OK", 
				nil, 
				nil, 
				mainWindow, 
				self, 
				nil, 
				nil, 
				nil, 
				NSLocalizedString(@"emptyexist",@""));
}

- (void)startProcess
{
	findRunning = YES;
	[extensionFrom setEnabled: NO];
	[extensionTo setEnabled: NO];
	[isMixerPatch setEnabled: NO];
	[isMixerVoice setEnabled: NO];
	[patchFile setEnabled: NO];
	[patchGame setEnabled: NO];
	[renameDir setEnabled: NO];
	[renameType setEnabled: NO];
	[saveDir setEnabled: NO];
	[seenDir setEnabled: NO];
	[selectButton1 setEnabled: NO];
	[selectButton2 setEnabled: NO];
	[selectButton3 setEnabled: NO];
	[selectButton4 setEnabled: NO];
	[selectButton5 setEnabled: NO];
	[startButton1 setEnabled: NO];
	[startButton2 setEnabled: NO];
	[startButton3 setEnabled: NO];
	[voiceDir setEnabled: NO];
	[voiceKind setEnabled: NO];
}

- (void)stopProcess
{
	findRunning = NO;
	[status1 setStringValue: @" "];
	[status2 setStringValue: @" "];
	[status3 setStringValue: @" "];
	[extensionFrom setEnabled: YES];
	[extensionTo setEnabled: YES];
	[isMixerPatch setEnabled: YES];
	[isMixerVoice setEnabled: YES];
	[patchFile setEnabled: YES];
	[patchGame setEnabled: YES];
	[renameDir setEnabled: YES];
	[renameType setEnabled: YES];
	[saveDir setEnabled: YES];
	[seenDir setEnabled: YES];
	[selectButton1 setEnabled: YES];
	[selectButton2 setEnabled: YES];
	[selectButton3 setEnabled: YES];
	[selectButton4 setEnabled: YES];
	[selectButton5 setEnabled: YES];
	[startButton1 setEnabled: YES];
	[startButton2 setEnabled: YES];
	[startButton3 setEnabled: YES];
	[voiceDir setEnabled: YES];
	[voiceKind setEnabled: YES];
}

- (void)patchFinished:(int)status
{
	[progressBar1 setDoubleValue: 0.0];
	if(status != 0) {
		NSBeginAlertSheet(
				@"Alert", 
				@"OK", 
				nil, 
				nil, 
				mainWindow, 
				self, 
				nil, 
				nil, 
				nil, 
				NSLocalizedString(@"endwitherror",@""));
	}
	else {
		NSBeginAlertSheet(
				@"Alert", 
				@"OK", 
				nil, 
				nil, 
				mainWindow, 
				self, 
				nil, 
				nil, 
				nil, 
				NSLocalizedString(@"patchok",@""));
		}
	[patchClient release];
	[self stopProcess];
}

- (void)expandFinished:(int)status
{
	[progressBar2 setDoubleValue: 0.0];
	//[progressBar2 setIndeterminate: NO];
	//[progressBar2 stopAnimation: self];
	if(status == 5) {
		NSBeginAlertSheet(
				@"Alert", 
				@"OK", 
				nil, 
				nil, 
				mainWindow, 
				self, 
				nil, 
				nil, 
				nil, 
				NSLocalizedString(@"afsnotfound",@""));
	}
	else if(status != 0) {
		NSBeginAlertSheet(
				@"Alert", 
				@"OK", 
				nil, 
				nil, 
				mainWindow, 
				self, 
				nil, 
				nil, 
				nil, 
				NSLocalizedString(@"endwitherror",@""));
	}
	else {
		NSBeginAlertSheet(
				@"Alert", 
				@"OK", 
				nil, 
				nil, 
				mainWindow, 
				self, 
				nil, 
				nil, 
				nil, 
				NSLocalizedString(@"expandok",@""));
		}
	[voiceClient release];
	[self stopProcess];
}

- (void)setStatusText:(NSString *)text1 text2:(NSString *)text2 text3:(NSString *)text3
{
	[status1 setStringValue: text1];
	[status2 setStringValue: text2];
	[status3 setStringValue: text3];
}

- (void)setProgressMaxValue:(double)val
{
	[progressBar3 setMaxValue: val];
}
- (void)addProgress
{
	[progressBar3 incrementBy: 1.0];
}


- (void)setProgressMaxValue2:(double)val
{
	[progressBar2 setMaxValue: val];
}
- (void)addProgress2
{
	[progressBar2 incrementBy: 1.0];
}
- (void)setCurrentProgress2:(double)val
{
	[progressBar2 setDoubleValue: val];
}

- (void)setProgressMaxValue1:(double)val
{
	[progressBar1 setMaxValue: val];
}
- (void)addProgress1
{
	[progressBar1 incrementBy: 1.0];
}

- (void)renameFinished
{
	[progressBar3 setDoubleValue: 0.0];
	NSBeginAlertSheet(
				@"Alert", 
				@"OK", 
				nil, 
				nil, 
				mainWindow, 
				self, 
				nil, 
				nil, 
				nil, 
				NSLocalizedString(@"renameok",@""));
	[renameClient release];
	[self stopProcess];
}

- (BOOL)windowShouldClose:(id)sender
{
	if(!findRunning) return YES;
	
	NSBeginAlertSheet(
				@"Close", 
				@"Cancel", 
				nil, 
				nil, 
				mainWindow, 
				self, 
				nil, 
				//@selector(alertSheetDidDismiss:returnCode:contextInfo:), 
				nil,
				nil, 
				NSLocalizedString(@"closewarn",@""));
	return NO;
}

- (void)windowWillClose:(NSNotification *)notification;
{
	[NSApp terminate:nil];
}

@end
